(* file = cbcom.pas
 *
 * cbcom : Jx\RpCFʕ		@ˑLinrAbotj
 *
 *
 * Copyright (C) 1990, 91, 92  Ockeghem
 *)

unit cbcom;

interface

const
	idsize = 31;	{ O̍ő咷 }
	maxstr = 255;
	HashSize = 997;
	HashSizeMinus1 = 996;	{ HashSize - 1 }
	MaxFileName = 64;
	MaxLengthOfCabezonString = 255;
	maxHexDigit = 4;
	minChar = 0;			{ @ˑ }
	maxChar = 255;			{ @ˑ }
	YES = 1;
	NO = 0;
	UndefinedLabel = -1;

	(************************ ͋@ˑ *************************)

	targetMinint = $8000;
	targetMaxint = 32767;
	targetMinByte = 0;
	targetMaxByte = 255;

	targetNearCallSize = 2;
	targetFarCallSize = 4;

	targetBoolSize = 1;
	targetByteSize = 1;
	targetCharSize = 1;
	targetIntegerSize = 2;
	targetLongIntSize = 4;
	targetPtrSize = 4;
	targetRealSize = 8;
	targetTextSize = 590;

	targetBoolAlign = 1;
	targetByteAlign = 1;
	targetCharAlign = 1;
	targetIntegerAlign = 2;
	targetPtrAlign = 2;
	targetRealAlign = 2;
	targetArgumentAlign = 2;
	targetTextAlign = 2;

	targetDynamicLinkSize = 2;
	targetStaticLinkSize = 2;

(************************ @ˑI *************************)

type
	refText = ^text;

	alpha = string[idsize];
	stringMax = string[maxstr];
	refAlpha = ^alpha;
	fileNameType = string[MaxFileName];
	refStringOfCabezon = ^StringOfCabezon;
	stringOfCabezon = string[MaxLengthOfCabezonString];

	stringBuf = string[maxstr];

	symbol = (ident, intConst, realConst, stringConst, notSym, fromTo, plus, 
			minus, orsym, xorsym, mulsym, divsym, rdiv, modsym, andsym, 

			(* leqqrtɑ̃V{}Ă͂ȂȂ *)

			leq, lss, eql, neq, geq, grt, lparen, rparen, lbracket, rbracket, 
			beginsym, endsym, comma, semicolon, colon, period, becomes, 
			stringsym, everysym, otherwisesym, stepsym, leavesym, withsym, 
			programsym, returnsym, arraysym, arrow, nilsym, insym, recordsym, 
			filesym, unitsym, interfacesym, usessym, implementationsym, 
			gotosym, ifsym, thensym, elsesym, whilesym, dosym, packedsym, 
			setsym, casesym, ofsym, repeatsym, untilsym, forsym, tosym, 
			downtosym, labelsym, constsym, typesym, varsym, proceduresym, 
			functionsym, hugesym, othersym);

	charKind = (Alphabet, Numeric, WhiteSpace, kanji1, 
				lparenChar, lbraquetChar, dollerChar, quoteChar, periodChar, 
				colonChar, lessChar, grtChar, otherChar);

	operation = (noop, addop, mulop, relop, indexop);
	idClass = (labels, types, constants, vars, fields, procedures, functions, 
			units, programs);
	idKind = (actual, formal);
	declareClass = (private, public, extern);
	declareKind = (standard, declared);
	structureForm = (scalars, subranges, pointers, powers, arrays, strings, 
			stringConsts, records, files);
	standardRoutines = (readRn, readlnRn, writeRn, writelnRn, newRn, 
			disposeRn, resetRn, rewriteRn, closeRn, eofRn, chrRn, ordRn, 
			absRn, strcatRn);
	operatorKinds = (opVariable, opConstant, opIndirect, opProcedure, 
			opFunction, operator, opRangeCheck);
	operators = (opMoveTo, opNeg, opNot, opCast, opAbs, opAdd, opSub, opMul, 
			opDiv, opMod, opAnd, opOr, opXor, opCmp, opLeq, opLss, opEql, 
			opNeq, opGeq, opGrt, opPush, opOthers);
	labelState = (undefined, forwardDeclared, defined, finished);
	errorKind = (warnings, errors, disasters);

	refConstant = ^constant;
	constant = record
		next : refConstant;
		strgValuePtr : refStringOfCabezon;
		intValue : integer;
		labelValue : integer
	end; { constant }

	refTagField = ^tagField;
	refVariant = ^variant;
	refStructure = ^structure;
	refIdentifier = ^identifier;
	refWithLink = ^withLink;
	refCaseInformation = ^caseInformation;
	refCaseLink = ^caseLink;
	refArgsLink = ^argsLink;
	refEvalTree = ^evalTree;

	tagField = record
		tagFieldType : refStructure;
		firstVariant : refVariant
	end;

	variant = record
		value : integer;
		size : integer;
		next : refVariant;
		subVariant : refTagField
	end;

	structure = record
		size : integer;
		alignmentUnit : integer;
		next : refStructure;
		isPacked, isHuge : boolean;
		case form : structureForm of
			scalars : (case scalarKind : declareKind of
					declared : (tailOfEnumration : refIdentifier);
					standard : ());	(*  *)
			subranges : 
				(rangeType : refStructure;
				 minValueOfSubrange, maxValueOfSubrange : integer);
			pointers : (elementTypeOfPointer : refStructure);
			powers : (elementTypeOfSet : refStructure);
			arrays : (arrayElementType, indexType : refStructure);
			stringConsts, strings : 
				(stringElementType : refStructure;
				 stringSize : integer);
			records : 
				(firstField : refIdentifier;
				 mainVariant : refTagField);
			files : (fileType : refStructure)
	end; { structure }

	identifier = record
		name : refAlpha;				{ O }
		idType : refStructure;			{ iď^ }
		level : integer;				{ XR[vEx }
		hashNext, next : refIdentifier;	{ nbV̗̎vf }
		hashValue : integer;			{ nbV֐l }
		labelValue : integer;			{ privatȅꍇ̃xl }
		variableAddress : integer;		{ ɂȂ̂   }
										{ 葱蓾 }
		idDeclareClass : declareClass;	{ private, public, extern }
		used : boolean;					{ gpς݂ۂ }
		variableKind : idkind;			{ actual or formal }
		case klass : idClass of
			labels : (referenceLevel : integer;
				state : labelState);
			constants : (values : constant);
			vars : ();
			fields : (fieldAddress : integer;
				llink, rlink : refIdentifier);
			procedures, functions, units, programs : (paramp : refIdentifier;
				argumentSize : integer;
				case procOrFuncKind : declareKind of
					standard : (key : standardRoutines);
					declared : (forwardDec : boolean;
						externDec : boolean));

						(* ӁFexternDec *)
						(* @BƂӖ  *)

			types : ();	(*  *)
	end; { identifier }

	refScopeLink = ^scopeLink;
	scopeLink = record
		parentScope : refScopeLink;
		procedurep : refIdentifier;
		returnValue : refIdentifier
	end;

	argsLink = record
		next : refArgsLink;
		exp : refEvalTree;
		argKind : idKind
	end; { argsLink }

	withLink = record
		next : refWithLink;
		offset : integer;
		withVar : refIdentifier;
		topOfField : refIdentifier
	end;

	caseInformation = record
		caseValue : integer;
		caseLabel : integer;
		next : refCaseInformation
	end;

	evalTree = record
		evalType : refStructure;
		case nodeType : operatorKinds of
			opVariable, opIndirect : (
				varIndex : refEvalTree;
				hugeIndex : refEvalTree;
				constIndex : integer;
				case boolean of
					false : (var1 : refIdentifier);	{ ڎQ }
					true : (ref1 : refEvalTree));	{ ԐڎQ }
			opConstant : (const1 : refConstant);
			opProcedure, opFunction : (func : refIdentifier;
				args : refArgsLink;
				size : integer);
			operator : (op : operators;
				operand1, operand2 : refEvalTree);
			opRangeCheck : (expr : refEvalTree;
				minValue, maxValue : integer)
	end; { evalTree }

	refFileInfoSave = ^fileInfoSave;
	fileInfoSave = record
		next : refFileInfoSave;
		saveSym : symbol;
		saveLineNo : integer;
		saveC : char;
		saveCp : integer;
		saveRbuf : stringBuf;
		saveInFile : refText;
		saveFname : fileNameType;
		saveInclude : boolean
	end;

	localRootSaverType = record
		idSave : refIdentifier;
		labelsSave : refIdentifier;
		typeSave : refStructure
	end;

	(* R[hpFbotˑ *)

	caseKind = 1..3;	(*  1 : QWv	     *)
						(*  2 : 萔Ɣѐ̑g̕\ *)
						(*  3 : e[uWv     *)
	caseLink = record
		jkind : caseKind;
		caseInformationPtr : refCaseInformation;
		labelOfCase, minValueOfCase, maxValueOfCase : integer;
		next : refCaseLink
	end;

	inSeg = (inNothing, inCode, inData, inBss);
	registers = (AXreg, BXreg, CXreg, DXreg, SIreg, DIreg, BPreg, SPreg, 
			DSreg, SSreg, ESreg, CSreg);

	regNameType = string[2];

var

	(* L *)

	sym : symbol;	{ ݂̃V{ }
	id : alpha;		{ ݂̖O }
	val : constant;	{ Ō̒萔 }
	programOrUnitName : alpha;

	(*  *)

	LineNo : integer;	{ ݂̍sԍ }
	c : char;			{ ݂̕ }
	cp : integer;		{ ݂̍s̈̕ʒu }
	Rbuf : stringBuf;	{ ݂̍s }
	InFile : refText;
	fname : fileNameType;	{ ݂̓̓t@C }
	inFileName, OutFileName : fileNameType;
	include, ioCheck, rangeCheck : boolean;

	fileInfoSaveLink : refFileInfoSave;	{ Ât@CL郊Xg }
	currentLevel : integer;				{ ݂̃x }
	OutFile : text;						{ o̓t@C }

	topOfScope : refScopeLink;
	currentRoutine : refIdentifier;		{ ݃RpC̎葱 }
	locationPtr : integer;				{ ݂̃P[VEJE^   }
	maxLocation : integer;				{ P[VEJE^̍ől }
	topOfWithLink : refWithLink;		{ with ̃N̐擪 }
	caseLabelsLink : refCaseLink;		{ casẽWve[u̐擪 }
	nErrors : array[errorKind] of integer;	{ G[̌ }
	errorExist : boolean;
	leaveLabel : integer;

	(* W̌^ *)

	intPtr, bytePtr, realPtr, charPtr, stringPtr, boolPtr, controlPtr, 
			pointerPtr, textPtr : refStructure;

	(* g֐E葱̃|C^ *)

	startUpPtr, intToRealPtr, strcmpPtr, strcatPtr, readCharPtr,
	readIntPtr, readRealPtr, readStringPtr, writeCharPtr, writeIntPtr,
	writeRealPtr, writeStringPtr, writeBoolPtr, skipNlPtr, writeLnPtr,
	writeStringNewlineCheckPtr, flushOutPtr, newMemPtr, newHugeMemPtr,
	newMemWIthCheckPtr, disposeMemPtr, disposeHugeMemPtr, ioCheckerPtr,
	ioChecker2Ptr, stringCopy1Ptr, stringCopy2Ptr, rangeCheck1Ptr,
	rangeCheck2Ptr : refIdentifier;

	(* gϐ *)

	inputPtr, outputPtr : refIdentifier;

	(* sɎgp⏕ϐFbotˑ *)

	stackFrameSaver, i8087Work1 : refIdentifier;

	(* ⏕̕\ *)

	symName : array[symbol] of string[14];	{ \̈󎚖 }
	opkind : array[symbol] of operation;	{ V{ƃIy[V̑Ή\ }
	(* sIvV *)

	listp : boolean;						{ Xgo͂s }
	generateDebuggingData : boolean;		{ fobOpo͂s }
	debug : boolean;				{ RpCg̃fobOo͂s }
	jumpOptimization : boolean;		{ jmp̃IveB}CY }
	lsiR86 : boolean;				{ LSI-Japen ̂WUgp }

	(* R[hFbotˑ *)

	floatCall : boolean;
	diVariable : refIdentifier;
	isActive : array[registers] of boolean;
	regName : array[registers] of string[2];
	opName : array[operators] of string[6];
	condJmpName1, condJmpName2 : array[boolean, opLeq..opGrt] of string[5];

	(* fobO\p̔z *)

	idClassName : array[idClass] of string[12];
	formName : array[structureForm] of string[10];
	idKindName : array[idKind] of string[6];
	opKindName : array[operatorKinds] of string[10];
	opesName : array[operators] of string[4];

implementation

end.
